#ifndef ROTOSAVER_H
#define ROTOSAVER_H

// ***************************************************************************
// System Includes
// ***************************************************************************

#include <add-ons/screen_saver/ScreenSaver.h> 
#include <Bitmap.h>
#include <GraphicsDefs.h>
#include <StringView.h> 

// ***************************************************************************
// Project Includes
// ***************************************************************************

// Standard type and constant definitions.
#include "StyleGuideDefs.h"

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/** 
 * RotoSaver is a simple screen saver for BeOS R4.5 or better.
 */
class RotoSaver : public BScreenSaver
{
public:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

	// Lifecycle -------------------------------------------------------------

	/** Constructor. */
	RotoSaver(BMessage* archive, image_id image);

	/** Automatically generated copy constructor. */
	// RotoSaver(const RotoSaver& old);

	/** Automatically generated destructor. */
	virtual ~RotoSaver(void);

	// Operators -------------------------------------------------------------

	/** Automatically generated assignment operator. */
	// RotoSaver& operator=(RotoSaver& right);

	// Operations ------------------------------------------------------------

	virtual void StartConfig(BView* view);
	
	virtual status_t StartSaver(BView* view, bool preview);

	virtual void StopSaver(void);
	
	virtual void Draw(BView* view, int32 frame);

	// Access ----------------------------------------------------------------

	// Inquiry ---------------------------------------------------------------

protected:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

private:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	/** The screen's color space. */
	color_space colorSpace;

	/** Pointer to the desktop's bitmap. */ 
	BBitmap* sourceBitmap;
  
	/** Pointer to the destination bitmap. */
	BBitmap* destBitmap;

	// Member Function Definitions ===========================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

extern "C" __declspec(dllexport)
BScreenSaver* instantiate_screen_saver(BMessage* msg, image_id id); 

#endif // ROTOSAVER_H
